/* 
 * Copyright (C) 2012 A. Pic
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <cstring>

#include "visa.h"
#include "object_cache.h"
#include "session.h"

using namespace librevisa;

ViStatus viBufWrite(ViSession vi, ViBuf buf, ViUInt32 count, ViUInt32 &/*retCount*/)
{
        try
        {
                session *s = objects.get_session(vi);

                /// @todo return VI_ERROR_RSRC_LOCKED if object locked

                if(s->GetFmtWriteBufCnt() + count >= s->GetFmtWriteBufSiz())
                        return VI_ERROR_IO;

                memcpy(s->GetFmtWriteBuf() + s->GetFmtWriteBufCnt(), buf, count);
                s->SetFmtWriteBufCnt(s->GetFmtWriteBufCnt() + count);

                return VI_SUCCESS;
        }
        catch(exception &e)
        {
                return e.code;
        }
}
